using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Net.Http;
using Newtonsoft.Json.Linq;
					
public class Program
{
	public static async Task Main()
	{
		// Request parameters
		string apiKey = "PCW45-12345-12345-1234X";
		string sortCode = "100000";
		string accountNumber = "31510604";

		// Prepare request and encode user-entered parameters with %xx encoding
		string requestUrl = $"https://ws.postcoder.com/pcw/{apiKey}/bank";
		
		var content = new Dictionary<string, string>
		{
			{ "sortcode", sortCode },
			{ "accountnumber", accountNumber }
		};
		var encodedContent = new FormUrlEncodedContent(content);

		using (HttpClient client = new HttpClient())
		{
			// Send request
			var response = await client.PostAsync(requestUrl, encodedContent);
			var responseContent = await response.Content.ReadAsStringAsync();

			// Process response
			if (response.IsSuccessStatusCode)
			{
				JObject responseJson = JObject.Parse(responseContent);
				Console.WriteLine($"{responseJson["valid"]}, {responseJson["bankname"]}, {responseJson["branchname"]}");
			}
			else
			{
				Console.WriteLine($"Request error: {responseContent}");
			}
		}
	}
}